<?

/****************************************************************************
IPSF - IPS - Framework
 + Projekt Klasse um die IPS Events zentral abzufangen und zu steuern



Release: 0.8      03.11.2014     Andi Zaugg

*****************************************************************************/


class IPSF {

   public function __construct($child){
      file_put_contents("tmp.txt",print_r($_IPS,1));
		$this->child = $child;

      $this->_STO = array();
      //$this->_STO = self::readSystemValues(self::getIdByPath("./".IPS_GetName($_IPS['SELF'])."/_internal/_STOCK"));

      self::createFolder("_internal",$_IPS['SELF'],1);
      self::createFolder("variables",$_IPS['SELF'],3);
		self::createVariable("_STOCK",$profile="",3,self::g("_internal.id"),1);
		self::readSystemValues(self::g("_STOCK.id"));

		//print_r($this->_STO);

      self::callChildFunction();
   }


   function __destruct(){
      self::writeSystemValues(self::g("_STOCK.id"), $this->_STO);
      //print_r($this->_STO);
      if(isset($this->destroyAllFlag)){
  			self::destroyByType($this->_STO,"link");
  			self::destroyByType($this->_STO,"var");
  			self::destroyByType($this->_STO,"folder");
  			self::destroyByType($this->_STO,"event");
  			self::destroyByType($this->_STO,"timeevent");
      }
   }


// SYSTEM ENV
//------------------------------------------------------------------------
	private function writeSystemValues($id,$params){
	   foreach($params as $k => $v){
	      if(isset($v['config'])){
	         unset($params[$k]['config']);
	      }
	      else{
	         if(!isset($v['bind'])){
	            if(IPS_ObjectExists($id) AND ($v['type'] != "timeevent")){
	               if($v['type'] == "event"){
	               	@IPS_DeleteEvent($v['id']);
	               }
	               else if($v['type'] == "link"){
	               	@IPS_DeleteLink($v['id']);
						}
	               else if($v['type'] == "var"){
	               	@IPS_DeleteVariable($v['id']);
	               }
      			}
	         }
	         unset($params[$k]);
	      }
	   }
	  	setValue($id,serialize($params));
	}

	private function readSystemValues($id){
		if($id){
	   	$params = @unserialize(getValue($id));
	   	if(is_array($params)){
		   	foreach($params as $k => $v){
					if(isset($k)){
						self::register($k,$v['id'],$v['type']);
						if(isset($v['bind'])){
							self::s($k.".bind","true");
						}
					}
				}
			}
	   }
	}

	public function bind($obj){
	   $objItem = explode(".",$obj);
	   if(count($objItem) > 1 AND (!self::g($objItem[0].".id"))){
			self::register($objItem[0],$objItem[1],"var");
			self::s($objItem[0].".bind","true");
		}
		self::s($objItem[0].".config","true");
	}

	public function register($name,$id,$type){
	   settype($id,"integer");
	   self::s("$name.id",$id);
	   self::s("$name.type",$type);
	   if(($type == "var") AND ($name != "_STOCK")){
	      if(@IPS_ObjectExists($id)){
	      	self::_s("$name.value",getvalue($id));
	      }
	   }
	}

	public function _s($obj,$value){
	   $objItem = explode(".",$obj);
	   if(count($objItem) > 1){
			$this->_STO[$objItem[0]][$objItem[1]] = $value;
		}
	}

	public function s($obj,$value){
	   $objItem = explode(".",$obj);
	   if(count($objItem) > 1){
			$this->_STO[$objItem[0]][$objItem[1]] = $value;
			if($objItem[1] == "value"){
	         if(@IPS_ObjectExists(intval(self::g($objItem[0].".id")))){
	            setValue(self::g($objItem[0].".id"),$value);
	         }
			}
		}
	   else{
	      foreach($this->_STO as $k => $v){
	         if(isset($v['id'])){
	            if($v['id'] == $obj){
	               $this->_STO[$k]['value'] = $value;
	               if($this->_STO[$k]['type'] == "var"){
	               	if(@IPS_ObjectExists($this->_STO[$k]['id'])){
	               	   setValue($this->_STO[$k]['id'],$value);
	               	}
	               }
	            }
	         }
	      }
	   }
	}

	public function g($obj){
	   $objItem = explode(".",$obj);
	   if(count($objItem) > 1){ return @$this->_STO[$objItem[0]][$objItem[1]];}
	   else{
	      foreach($this->_STO as $k => $v){
	         if(isset($v['id'])){
	            if($v['id'] == $obj){
	               return $k;
	            }
	         }
	      }
	   }
	}


// SYSTEM FUNCTIONS
//------------------------------------------------------------------------
	public function destroyAll(){
	      $this->destroyAllFlag = true;
	}


	private function destroyByType(&$var,$type){
		foreach($var as $k => $v){
	     if(($v['type']) == $type AND ($type=="link")){
			IPS_DeleteLink($v['id']);
			unset($var[$k]);unset($var[$v['id']]);
	     }
	     if(($v['type']) == $type AND ($type=="var")){
			IPS_DeleteVariable($v['id']);
			unset($var[$k]);unset($var[$v['id']]);
	     }
	     if(($v['type']) == $type AND ($type=="folder")){
			IPS_DeleteCategory($v['id']);
			unset($var[$k]);unset($var[$v['id']]);
	     }
	     if(($v['type']) == $type AND ($type=="event")){
			IPS_DeleteEvent($v['id']);
			unset($var[$k]);unset($var[$v['id']]);
	     }
	  }
	}


// EVENTS
//------------------------------------------------------------------------
   private function callChildFunction(){
      //$_IPS['VARIABLE'] = 45628 /*[Objekt #45628 existiert nicht]*/ ;
      //$_IPS['SENDER'] = "WebFront";
      //$_IPS['SENDER'] = "TimerEvent";
      //$_IPS['EVENT'] = 17865 /*[Objekt #17865 existiert nicht]*/ ;
      //print_r($_IPS);

      if(isset($_IPS['VARIABLE']) AND ($_IPS['SENDER'] == "WebFront")){
         $VNA=IPS_GetName($_IPS['VARIABLE']);
         // CUSTOM ACTION
         if(is_callable(array($this->child, 'customAction_'.$VNA))){
				if($this->debug){echo "call customAction_".$VNA;}
            call_user_func(array($this->child, 'customAction_'.$VNA));
         }
      }
      if(isset($_IPS['TRIGGER']) AND ($_IPS['TRIGGER'] == "OnChange")){
         $VNA=str_replace("_event","",self::g($_IPS['EVENT']));
         // CUSTOM ACTION
         if($this->debug){echo "\ntry to find onChange_".$VNA."\n";}
         if(is_callable(array($this->child, 'onChange_'.$VNA))){
            if($this->debug){echo "call onChange_".$VNA;}
            call_user_func(array($this->child, 'onChange_'.$VNA));
         }
      }
      if(isset($_IPS['TRIGGER']) AND ($_IPS['TRIGGER'] == "OnUpdate")){
         $VNA=str_replace("_event","",self::g($_IPS['EVENT']));
         // CUSTOM ACTION
         if($this->debug){echo "\ntry to find onUpdate_".$VNA."\n";}
         if(is_callable(array($this->child, 'onUpdate_'.$VNA))){
            if($this->debug){echo "call onUpdate_".$VNA;}
            call_user_func(array($this->child, 'onUpdate_'.$VNA));
         }
      }
      if(isset($_IPS['TRIGGER']) AND ($_IPS['TRIGGER'] == "OnLimitExceed")){
         $VNA=str_replace("_event","",self::g($_IPS['EVENT']));
         // CUSTOM ACTION
         if($this->debug){echo "\ntry to find onChangeUp_".$VNA."\n";}
         if(is_callable(array($this->child, 'onChangeUp_'.$VNA))){
            if($this->debug){echo "call onChangeUp_".$VNA;}
            call_user_func(array($this->child, 'onChangeUp_'.$VNA));
         }
      }
      if(isset($_IPS['TRIGGER']) AND ($_IPS['TRIGGER'] == "OnLimitDrop")){
         $VNA=str_replace("_event","",self::g($_IPS['EVENT']));
         // CUSTOM ACTION
         if($this->debug){echo "\ntry to find onChangeDown_".$VNA."\n";}
         if(is_callable(array($this->child, 'onChangeDown_'.$VNA))){
            if($this->debug){echo "call onChangeDown_".$VNA;}
            call_user_func(array($this->child, 'onChangeDown_'.$VNA));
         }
      }
      if(isset($_IPS['SENDER']) AND ($_IPS['SENDER'] == "TimerEvent")){
         $VNA=IPS_GetName($_IPS['EVENT']);
         // CUSTOM ACTION
         if(is_callable(array($this->child, 'timeEvent_'.$VNA))){
            if($this->debug){echo "call timeEvent_".$VNA;}
            call_user_func(array($this->child, 'timeEvent_'.$VNA));
         }
      }


   }

   public function createOnChangeUpEvent($obj,$value){
		$eid = self::createValueEvent($obj,"",2,$value);
      IPS_SetEventTriggerValue($eid, $value);
      IPS_SetEventTriggerSubsequentExecution($eid, false);
   }

   public function createOnChangeDownEvent($obj,$value){
		$eid = self::createValueEvent($obj,"",3,$value);
      IPS_SetEventTriggerValue($eid, $value);
      IPS_SetEventTriggerSubsequentExecution($eid, false);
   }

   public function createOnChangeEvent($obj){
		self::createValueEvent($obj,"",1);
   }

   public function createOnUpdateEvent($obj){
		self::createValueEvent($obj,"",0);
   }

   public function createValueEvent($obj,$name="",$trigger=1,$value=""){
      $value = str_replace(".","",$value);
      $name = self::g(self::g($obj)).$value."_event";
      $VID = @IPS_GetObjectIDByName($name, $_IPS['SELF']);
      if($VID){ self::register($name,$VID,"event"); self::s($name.".config","true"); return $VID; }

      $eid = IPS_CreateEvent(0);
      self::register($name,$eid,"event");
      IPS_SetEventTrigger($eid, $trigger, self::g($obj));
      IPS_SetParent($eid, $_IPS['SELF']);
      IPS_SetEventActive($eid, true);
      if(!IPS_SetName($eid,$name)){ return false;}

      self::s($name.".config","true");
      return $eid;
   }

   public function createTimeEvent($name){
      //echo self::g("$name.id");
		if(!self::g("$name.id")){
		   $eid = IPS_CreateEvent(1);
			IPS_SetParent($eid, $_IPS['SELF']);
		   self::register($name,$eid,"timeevent");
		   IPS_SetName($eid,$name);
		   IPS_SetEventActive($eid, true);
		   return $eid;
	   }
	   else {
	      return $this->_STO[$name]['id'];
	   }

   }

   public function deleteEvent($id){
		if(IPS_ObjectExists($id)){
	      @IPS_DeleteEvent($id);
      }
	   $name = @self::g($id);
	   unset($this->_STO[$name]);
   }


// VARIABLEN UND LINKS
//------------------------------------------------------------------------
   public function createFolder($name,$parent,$position=0){
      $VID = @IPS_GetObjectIDByName($name, $parent);
      if($VID){ self::register($name,$VID,"folder"); self::s($name.".config","true"); return $VID; }

      $VID = IPS_CreateCategory();
      $this->$name = $VID;self::register($name,$VID,"folder");
      if(!IPS_SetName($VID,$name)){ return false;}
      if(!IPS_SetParent($VID,$parent)){ return false;}
      IPS_SetPosition($VID,$position);
      self::s($name.".config","true");
   }


   public function createButton($name,$profile="",$position=1){
      return $this->createVariable($name,$profile,0,"",$position);
   }


   public function createString($name,$profile="",$position=1){
		return $this->createVariable($name,$profile,3,"",$position);
   }


   public function createInteger($name,$profile="",$position=1){
		return $this->createVariable($name,$profile,1,"",$position);
   }

   public function createFloat($name,$profile="",$position=1){
		return $this->createVariable($name,$profile,2,"",$position);
   }


   private function createVariable($name,$profile,$type=0,$parent="",$position){
		if(!$parent){ $parent = self::g("variables.id");}
      $VID = @IPS_GetVariableIDByName($name, $parent);
      if($VID){ self::register($name,$VID,"var");self::s($name.".config","true"); return $VID;}

      $VID=IPS_CreateVariable($type);
		$this->$name = $VID;self::register($name,$VID,"var");
      if(!IPS_SetName($VID,$name)){ return false;}
      if(!IPS_SetParent($VID,$parent)){ return false;}
      if($profile){
      if(!IPS_SetVariableCustomProfile($VID,$profile)){ return false;}
}
      if(!IPS_SetVariableCustomAction($VID,self::g("variables.id"))){ return false;}
      IPS_SetPosition($VID,$position);
      self::s($name.".config","true");
   }


   public function createLink($name,$target,$path,$position=1){
      $objItem = explode(".",$target);
	   if(count($objItem) > 1){
	      $target = self::g($target);
	   }
   
      $parent = self::getIdByPath($path);
      if(!$parent){ return false; }
      $VID = @IPS_GetObjectIDByName($name, $parent);
      if($VID){ self::register($name,$VID,"link");self::s($name.".config","true");return $VID; }


      $VID=IPS_CreateLink();
      self::register($name,$VID,"link");
      if(!IPS_SetLinkTargetID($VID,$target)){ return false;}
      if(!IPS_SetName($VID,$name)){ return false;}
      if(!IPS_SetParent($VID,$parent)){ return false;}
      IPS_SetPosition($VID,$position);
      self::s($name.".config","true");
   }




// MANIPULATING ---------------------------------------------------------
// AUTHOR:tgusi74
// http://www.ip-symcon.de/forum/threads/7231-IPS-Variablenzugriffe-ber-NAMEN


	public function getIdByPath($ObjectString)
	{
	 $NewID = 0; //RootID
	 $ObjectString = str_replace(chr(92),"/",$ObjectString);
	 $msgtxt = "";


	 if (substr($ObjectString,0,1) == "/")
	 {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
		     global $_IPS;
		$NewID = $_IPS['SELF'];
		$ObjectString = substr($ObjectString,1);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
	 }


	 if (substr($ObjectString,0,2) == "./")
	 {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
		     global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$NewID = $ObjectInfo['ParentID'];
		$ObjectString = substr($ObjectString,2);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
	 }


	 if (substr($ObjectString,0,3) == "../")
	 {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene hher einordnen (Ebene ber Script)
		     global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
		$NewID = $ObjectInfo['ParentID'];
		$ObjectString = substr($ObjectString,3);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
	 }


	 foreach (explode("/", $ObjectString) as $NameTag)
	  {
	if ($NameTag != "")
	{
	    $PrevID = $NewID;
	    $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
	    if (IPS_GetName($NewID) != $NameTag)
	    {
	    echo("FEHLER: Objekthierachie '" . $NameTag . "' existiert nicht !! ("  . $msgtxt . $ObjectString .")\r\n");
	break;
	return false;
	       }
	}
	}
	return $NewID;
	}


// ----------------------------------------------------------------------
}

?>
