<?
 include_once('18162.ips.php');

 class IPSF_alarm extends IPSF {

   public function __construct($state=""){
    // do not delete
      $this->debug = true;
		parent::__construct($this);
		self::init();
   }


   public function init(){
      
	// in diesem Bereich findet die deklaration statt
	// ACHTUNG: Werden Variablen erstellt, und spter aus der init wieder entfernt,
	// 			so lscht IPSF diese Variablen
	
      self::createInteger("abfragevariable");
      self::createOnChangeEvent("abfragevariable.id");
      self::createOnChangeUpEvent("abfragevariable.id",4);
      self::createOnChangeDownEvent("abfragevariable.id",2);
      
      self::createInteger("onChangeVara");
      self::createInteger("onChangeUpVara");
      self::createInteger("onChangeDownVara");
      self::createLink("Mein Link","abfragevariable.id","visu/alarm",1);
	}
	
	public function onChange_abfragevariable(){
		self::s("onChangeVara.value",self::g("onChangeVara.value")+1);
	}

	public function onChangeUp_abfragevariable4(){
		self::s("onChangeUpVara.value",self::g("onChangeUpVara.value")+1);
	}

	public function onChangeDown_abfragevariable2(){
		self::s("onChangeDownVara.value",self::g("onChangeDownVara.value")+1);
	}

}

// EINRICHTEN DES IPSF
// ------------------------------------------------------------
/*
	1)	Die IPSF class kann irgendwo zentral abgelegt werden
	2) Fr jedes Projekt empfiehlt sich ein eigenes IPSF Script zu erstellen
		IPSF_meinprojekt -> include muss auf die IPS class zeigen
		
	3) init() function fllen     -> siehe Beispiel weiter oben
	4) events schreiben ;-)       -> siehe Beispiel weiter oben
	
/*




// BASIS FUNKTIONALITAETEN
// ------------------------------------------------------------
/*
   self::createButton(NAME,{PROFILE},{POSITION});
   --> erstellt eine Boolean Variable im Verzeichnis "variables"
			Wird Deklaration aus der init() wieder rausgelscht,
			lscht IPSF automatisch die Variable wieder aus dem
			Verzeichnis "variables"
			--> NAME: string
			--> PROFILE: string/optional
			--> POSITION: integer/optional, position das Variable

	Beispiel
   self::createButton("meinBool","~switch");
   
   
//--------

   self::createInteger(NAME,{PROFILE},{POSITION});
   --> erstellt eine Integer Variable im Verzeichnis "variables"
			Wird Deklaration aus der init() wieder rausgelscht,
			lscht IPSF automatisch die Variable wieder aus dem
			Verzeichnis "variables"
			--> NAME: string
			--> PROFILE: string/optional
			--> POSITION: integer/optional, position das Variable
		
	Beispiel
   self::createInteger("meinInt");

//--------

   self::createFloat(NAME,{PROFILE},{POSITION});
   --> erstellt eine Float Variable im Verzeichnis "variables"
			Wird Deklaration aus der init() wieder rausgelscht,
			lscht IPSF automatisch die Variable wieder aus dem
			Verzeichnis "variables"
			--> NAME: string
			--> PROFILE: string/optional
			--> POSITION: integer/optional, position das Variable

	Beispiel
   self::createFloat("meinFloat");

//--------

	self::bind(NAME.object id);
	--> erstellt eine Verbindung ausserhalb des Verzeichnisses
	      Bei rauslschen aus der init(), wird lediglich die
	      Verknpfung rausgelscht.
			--> NAME: string  gewnschter Name mit (.) vorhandener object id
	      
	Beispiel
   self::bind("aktor_2OG.53241");    Homematic Device Switch


//--------

	self::link(NAME, TARGETID, PATH, {POSITION});
	--> erstellt einen Link in ein Verzeichnis
			--> NAME: string - hier drfen auch Namen mit Leerzeichen verwendet werden
			--> TARGET: objectid oder IPSF Object
			--> PATH: string, Pfad gemss http://www.ip-symcon.de/forum/threads/7231-IPS-Variablenzugriffe-ber-NAMEN
			--> POSITION: integer/optional
	

	Beispiel
   self::createLink("Mein Link","abfragevariable.id","visu/alarm",1);
   oder
   self::createLink("Mein Link",53241,"visu/alarm",1);
   
   

// GET / SET FUNKTIONALITAETEN
// ------------------------------------------------------------

	variant = self:g(Object (.) SUBTYPE);
	--> liefert den Object Wert zurck
			--> TARGET: objectid oder IPSF Object
			--> SUBTYPE: (.id), (.value), (.type)

	Beispiel
	echo self::g("abfragevariable.value");
	      AUSGABE: 5
	      
	echo self::g("abfragevariable.id");
	      AUSGABE: 54222

	echo self::g(54222);
	      AUSGABE: abfragevariable

	echo self::g("abfragevariable.type");
	      AUSGABE: var


//--------

	self::s(Object (.) SUBTYPE, VALUE);
			--> TARGET: objectid oder IPSF Object
			--> SUBTYPE: (.value)
			--> VALUE: variant
			
  Beispiel
  self:s("abfragevariable.value", 13);
         --> die variable wird mit 13 gesetzt
         


// EVENT TRIGGER
// ------------------------------------------------------------
// Soooo, jetzt wird es spannend!

   self::createOnChangeEvent("abfragevariable.id");
         --> Wenn sich die Variable verndert wird der IPSF Event aufgerufen

	Folgendes wird versucht aufzurufen (sofern es existiert)
	
	public function onChange_abfragevariable(){
	   echo "Ja, Event ist angekommen"
	}
         

//--------

   self::createOnChangeUpEvent("abfragevariable.id",50);
         --> Wenn der Wert 50 erreicht hat, wird der IPSF Event aufgerufen
         
	Folgendes wird versucht aufzurufen (sofern es existiert)

	public function onChangeUp_abfragevariable50(){
	   echo "Ja, Event mit 50 ist angekommen"
	}


//--------

   self::createOnChangeDownEvent("abfragevariable.id",10);
         --> Wenn der Wert unter 10 gefallen ist, wird der IPSF Event aufgerufen

	Folgendes wird versucht aufzurufen (sofern es existiert)

	public function onChangeDown_abfragevariable10(){
	   echo "Ja, Event unter 10 ist angekommen"
	}


*/
// ------------------------------------------------------------



 $alarm = new IPSF_alarm();
 
 ?>